package  {
import flash.text.TextColorType;
import flash.text.CSMSettings;
import flash.text.TextFormat;
import flash.text.TextRenderer;
import flash.events.MouseEvent;
import flash.text.FontStyle;
import flash.display.Sprite;
import flash.text.TextField;
import flash.events.Event;
import flash.text.AntiAliasType;
import flash.text.TextFieldAutoSize;

public class ExampleAdvancedText extends Sprite {
  [Embed(source='lib/Vera.ttf',	// Embedメタデータタグ (devguide_flex3, P.497)
         fontName='myFont',
         mimeType='application/x-font',
         unicodeRange='U+0041-U+005A,U+0061-U+007A')]
  private var myFont:Class;

  public function ExampleAdvancedText():void {
    super();
    var format:TextFormat = new TextFormat();
    format.color = 0x336699;
    format.size = 48;		// フォントサイズ
    format.font = "myFont";	// フォント名
    var myText:TextField = new TextField();
    myText.embedFonts = true;	// 埋め込みフォント
    myText.autoSize = TextFieldAutoSize.LEFT;
    myText.antiAliasType = AntiAliasType.ADVANCED; // TextRendererを使用する場合
    myText.defaultTextFormat = format;
    myText.selectable = false;
    myText.mouseEnabled = true;
    myText.text = "Hello World?";
    addChild(myText);
    myText.addEventListener(MouseEvent.CLICK, clickHandler);
  }
  protected function clickHandler(event:Event):void {
    var myAntiAliasSettings:CSMSettings = new CSMSettings(
      48,	// fontSize;		ターゲットとなるフォントサイズ
      2,	// insideCutoff;	これを大きくすると細く滑らかになる
      -0	// outsizeCutoff;	これを大きくすると太く滑らかになる
    );
    var myAliasTable:Array = [myAntiAliasSettings];
    TextRenderer.setAdvancedAntiAliasingTable(
      "myFont", FontStyle.REGULAR,	// ターゲットとなるフォント名とスタイル
      TextColorType.DARK_COLOR,		// 線が濃い(DARK_COLOR)か、薄い(LIGHT_COLOR)か
      myAliasTable			// 所望の CSMSettings
    );
  }
}

}
