package {
import flash.display.DisplayObject;
import flash.net.URLRequest;
import flash.text.TextFormat;
import flash.events.MouseEvent;
import flash.display.SimpleButton;
import flash.media.Sound;
import flash.display.Sprite;
import flash.media.SoundChannel;

public class ExampleURLSound extends Sprite {
  protected var snd:Sound;
  protected var sndc:SoundChannel;
  protected var items:Array;
  protected var fs:Array;

  public function ExampleURLSound():void {
    super();
    var s:Number = 16.0;
    fs = [
      new TextFormat("Courier", s, 0x000000),
      new TextFormat("Webdings", s, 0x000000),
    ];
    items = [
      new Label("URL",	fs[0], 0, 0, [s*2, s]),
      new Label("",	fs[0], 1, 0, [s*32, s]),
      new SimpleButton(),
    ];
    transition();
    items[2].addEventListener(MouseEvent.CLICK, pbPlay);
    items[0].x = items[0].y = 4;
    layouts(0, [items[0], items[1], items[2]]);
    for each (var item:DisplayObject in items)
      addChild(item);
  }
  protected function layouts(type:int, items:Array):void {
    var i:int;

    switch (type) {
    case 0:
      for (i=1; i<items.length; i++) {
        items[i].x = items[i-1].x + items[i-1].getRect(this).width + 4;
        items[i].y = items[i-1].y;
      }
      break;
    case 1:
      for (i=1; i<items.length; i++) {
        items[i].x = items[i-1].x;
        items[i].y = items[i-1].y + items[i-1].getRect(this).height + 4;
      }
      break;
    }
  }
  protected function transition():void {
    items[2].upState      = new Label((snd!=null)?"\x55":"\x56", fs[1], 2, 0);
    items[2].overState    = new Label((snd!=null)?"\x55":"\x56", fs[1], 2, 1);
    items[2].downState    = new Label((snd!=null)?"\x55":"\x56", fs[1], 2, 2);
    items[2].hitTestState = new Label((snd!=null)?"\x55":"\x56", fs[1], 2);
  }
  public function pbPlay(event:MouseEvent):void {
    if (snd == null) {
      if (items[1].tf.text != null) {
        snd = new Sound(new URLRequest(items[1].tf.text));
        sndc = snd.play();
      }
    }
    else {
      sndc.stop();
      snd = null;
    }
    transition();
  }
}

}
